&IF FALSE &THEN 
/*
Description:     Debug message include file

    All code in this file is in one statement so can be used as a pseudo-command
    
    WARNING: Including this file may corrupt RETURN-VALUE

    Copy of CMS codbgfmsg0.i 
    
Arguments:
	
	(Preprocessor)
	   m   -   Used as a message
	   {1} -   Special flag value. Values can be:
	           BUFFER  -   Specifies that {2} is a buffer name and we want
	                       a listing of all fields in the buffer sent to
	                       the debug log. Rest of {3} {4} etc can be normal fields
	                       to output alongside buffer contents.
               BUFFER-HANDLE - Specifies that {2} is a buffer handle name and we
                               want a listing of it's contents
	
Comments:

    ** VERY IMPORTANT **
    Keep ALL code in this file within one statement, so it can be
    used as follows:

        IF something THEN
        DO:
            ...
            ...
        END.
        ELSE
            {codbgfmsg0.i x y z}

    If there's more than one statement within this include then the above
    will NOT function correctly

    You should include coDbgfdef0.i at the top of your program in order
    to use this file


Arguments:
	
Comments:



************************************************************************/
&ENDIF
DO: /* Debug Include {adbgmsg0.i} */
    IF GoisDebug = "YES"
    THEN DO: 
        &IF "{1}" = "BUFFER" OR "{1}" = "BUFFER-HANDLE" &THEN
            &IF "{1}" = "BUFFER" &THEN RUN acoutfn0.p (INPUT BUFFER {2}:HANDLE). &ELSE RUN acoutfn0.p (INPUT {2}).
            &ENDIF
            {adbgmsg0.i RETURN-VALUE {3} {4} {5} {6} {7} {8} {9} {10} {11} {12} {13} {14} {15} } 
&ELSE IF VALID-HANDLE(GhDebugWindowProc) AND
            LOOKUP("PReceiveDebugMessage",GhDebugWindowProc:INTERNAL-ENTRIES) > 0
        THEN
            RUN PReceiveDebugMessage IN GhDebugWindowProc 
                (PROGRAM-NAME(1) + CHR(1) &if "{&m}" <> "" &then + "{&m}" + CHR(1) &endif
                &if "{1}" <> "" &then + "{1} = " + (IF {1} <> ? THEN STRING({1}) ELSE "?") + CHR(1)
                &if "{2}" <> "" &then + "{2} = " + (IF {2} <> ? THEN STRING({2}) ELSE "?") + CHR(1)
                &if "{3}" <> "" &then + "{3} = " + (IF {3} <> ? THEN STRING({3}) ELSE "?") + CHR(1)
                &if "{4}" <> "" &then + "{4} = " + (IF {4} <> ? THEN STRING({4}) ELSE "?") + CHR(1)
                &if "{5}" <> "" &then + "{5} = " + (IF {5} <> ? THEN STRING({5}) ELSE "?") + CHR(1)
                &if "{6}" <> "" &then + "{6} = " + (IF {6} <> ? THEN STRING({6}) ELSE "?") + CHR(1)
                &if "{7}" <> "" &then + "{7} = " + (IF {7} <> ? THEN STRING({7}) ELSE "?") + CHR(1)
                &if "{8}" <> "" &then + "{8} = " + (IF {8} <> ? THEN STRING({8}) ELSE "?") + CHR(1)
                &if "{9}" <> "" &then + "{9} = " + (IF {9} <> ? THEN STRING({9}) ELSE "?") + CHR(1)
                &if "{10}" <> "" &then + "{10} = " + (IF {10} <> ? THEN STRING({10}) ELSE "?") + CHR(1)
                &if "{11}" <> "" &then + "{11} = " + (IF {11} <> ? THEN STRING({11}) ELSE "?") + CHR(1)
                &if "{12}" <> "" &then + "{12} = " + (IF {12} <> ? THEN STRING({12}) ELSE "?") + CHR(1)
                &if "{13}" <> "" &then + "{13} = " + (IF {13} <> ? THEN STRING({13}) ELSE "?") + CHR(1)
                &if "{14}" <> "" &then + "{14} = " + (IF {14} <> ? THEN STRING({14}) ELSE "?") + CHR(1)
                &if "{15}" <> "" &then + "{15} = " + (IF {15} <> ? THEN STRING({15}) ELSE "?") + CHR(1)
            &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif).
        ELSE
            MESSAGE PROGRAM-NAME(1) SKIP(1) &if "{&m}" <> "" &then "{&m}" SKIP &endif
                    &if "{1}" <> "" &then "{1}" {1} SKIP
                    &if "{2}" <> "" &then "{2}" {2} SKIP
                    &if "{3}" <> "" &then "{3}" {3} SKIP
                    &if "{4}" <> "" &then "{4}" {4} SKIP
                    &if "{5}" <> "" &then "{5}" {5} SKIP
                    &if "{6}" <> "" &then "{6}" {6} SKIP
                    &if "{7}" <> "" &then "{7}" {7} SKIP
                    &if "{8}" <> "" &then "{8}" {8} SKIP
                    &if "{9}" <> "" &then "{9}" {9} SKIP
                    &if "{10}" <> "" &then "{10}" {10} SKIP
                    &if "{11}" <> "" &then "{11}" {11} SKIP
                    &if "{12}" <> "" &then "{12}" {12} SKIP
                    &if "{13}" <> "" &then "{13}" {13} SKIP
                    &if "{14}" <> "" &then "{14}" {14} SKIP
                    &if "{15}" <> "" &then "{15}" {15} SKIP
                 &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif &endif VIEW-AS ALERT-BOX INFORMATION. &ENDIF
    END.
END. &IF "{&m}" <> "" &THEN &UNDEFINE m &ENDIF
