/*
Description: Functions for retrieving and setting global variables in V9
objects.

Arguments:
	
Comments:


************************************************************************/

FUNCTION FlSetGlobalList
    RETURNS LOG (INPUT IcVarValueList AS CHAR):

    /* Set a number of globals. Input parameter is pipe-separated var=value list */

    RUN agblsfn2.p (INPUT IcVarValueList).

END.

FUNCTION FlSetGlobal
    RETURNS LOG (INPUT IcGlobalVarName AS CHAR, INPUT IcValue AS CHAR):

    /* Set a single global variable to a given value */

    RETURN FlSetGlobalList (SUBST("&1=&2",IcGlobalVarName,IcValue)).
END.

FUNCTION FcGetGlobal
    RETURNS CHAR (INPUT IcGlobalVarName AS CHAR):

    /* Retrieve the value of a 'global' variable as a character */

    DEFINE VARIABLE OcValue             AS CHAR             NO-UNDO.

    RUN agblsfn1.p 	(INPUT IcGlobalVarName,
                      	OUTPUT OcValue).
    IF RETURN-VALUE > "" THEN
    DO:
        MESSAGE "Error evaluating global variable:" IcGlobalVarName SKIP
                "Error message:" RETURN-VALUE
            VIEW-AS ALERT-BOX.
        RETURN "".
    END.

    RETURN OcValue.

END.

FUNCTION FiGetGlobal
    RETURNS INTEGER (INPUT IcGlobalVarName AS CHAR):

    /* Retrieve the value of a 'global' variable as an integer */

    DEFINE VARIABLE OcCharValue         AS CHAR             NO-UNDO.
    DEFINE VARIABLE OiIntValue          AS INTEGER          NO-UNDO.
    
    /* Retrieve as char first */
    OcCharValue = FcGetGlobal (INPUT IcGlobalVarName).
    IF OcCharValue = "" OR OcCharValue = ? THEN
        RETURN ?.

    /* Convert to int */
    OiIntValue = INT(OcCharValue) NO-ERROR.
    IF OiIntValue = ? THEN
    DO:
        MESSAGE "Error converting global variable to integer:" IcGlobalVarName SKIP
                "Character value:" OcCharValue
            VIEW-AS ALERT-BOX.
        RETURN ?.
    END.

    RETURN OiIntValue.

END.
