&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*
Description: Smart Container Super Procedure

    Sits before containr.p in the super-procedure stack for each container
    Copy of CMS cocontsup0.p
    
Arguments:
        
Comments:


************************************************************************/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

{adbgdef0.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 10.62
         WIDTH              = 41.29.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/*
 * &IF "{&FRAME-NAME}" <> "" &THEN
 * 
 * FUNCTION getFrameNameHandle
 *     RETURNS HANDLE:
 * 
 *     RETURN FRAME {&FRAME-NAME}:HANDLE.
 * END.
 * 
 * &ENDIF
 * */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-applyEntry) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE applyEntry Procedure 
PROCEDURE applyEntry :
/*------------------------------------------------------------------------------
  Purpose:     Copy of the version from smart.p
               This version applies entry to the container handle if no enabled
               widgets have been found
               
               
               Applies "ENTRY" to the first enabled and visible object 
               in the default frame (unless pcField is specified), 
               or in the first child which is a Frame.
  Parameters:  pcField AS CHARACTER -- optional fieldname; if specified,
               the frame field of that name will be positioned to.
------------------------------------------------------------------------------*/

  DEFINE INPUT PARAMETER pcField  AS CHARACTER NO-UNDO.
  
  DEFINE VARIABLE hContainer      AS HANDLE NO-UNDO.
  DEFINE VARIABLE hWidget         AS HANDLE NO-UNDO.

    IF pcField = ? THEN pcField = "":U.
    
    {get ContainerHandle hContainer}.
    IF VALID-HANDLE(hContainer) THEN
    DO:     
       DO WHILE hContainer:TYPE = "WINDOW":U: 
           hContainer = hContainer:FIRST-CHILD.    
       END.
       ASSIGN hWidget = hContainer:CURRENT-ITERATION
              hWidget = hWidget:FIRST-TAB-ITEM.
          
        DO WHILE VALID-HANDLE(hWidget) :      
          IF hWidget:SENSITIVE AND hWidget:VISIBLE AND
            (pcField = "":U OR hWidget:NAME = pcField) THEN
          DO:
                /* In case the new widget with focus is not in the
                   CURRENT-WINDOW, change CURRENT-WINDOW to be the
                   window of the new widget; otherwise it won't actually
                   get focus. */
                DO WHILE (VALID-HANDLE(hContainer) AND 
                  hContainer:TYPE NE "WINDOW":U):
                    hContainer = hContainer:PARENT.
                END.
                IF hContainer:TYPE = "WINDOW":U THEN
                DO:
                  CURRENT-WINDOW = hContainer.
                  
                  /* OIS - Added this to make smart.p version work! */
                  APPLY "ENTRY" TO CURRENT-WINDOW.
                END.

                APPLY "ENTRY":U TO hWidget.                
                RETURN.
          END.
          ELSE ASSIGN hWidget = hWidget:NEXT-TAB-ITEM.            
        END.

    END.  

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-PChildClosingPre) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PChildClosingPre Procedure 
PROCEDURE PChildClosingPre :
/*------------------------------------------------------------------------------
  Purpose:   if the container is a window then set it to be the current window  
       
------------------------------------------------------------------------------*/
    DEFINE VARIABLE VhContainerHandle                   AS HANDLE       NO-UNDO.

    {get ContainerHandle VhContainerHandle}.
    
    IF VhContainerHandle:TYPE = "WINDOW"
    THEN CURRENT-WINDOW = VhContainerHandle.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-PFixFolderZOrder) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PFixFolderZOrder Procedure 
PROCEDURE PFixFolderZOrder :
/*------------------------------------------------------------------------------
  Purpose:     For this container, look for all folders and do a MOVE-TO-BOTTOM
               on the frame handle of each folder.

               This publish works because the folder has PEVENTMoveToBottom
               included as a pageTargetEvent, so the folder will subscribe to
               PEVENTMoveToBottom in its page target (its container).

               Also does same for splitter(s) inside the container.
------------------------------------------------------------------------------*/

    PUBLISH "PEVENTMoveToBottom" FROM TARGET-PROCEDURE.
    
    /* Splitter must be on the bottom, even below folders */
    PUBLISH "PEVENTMoveToBottomSplitter" FROM TARGET-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-POpenSDOQueriesOnPage) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE POpenSDOQueriesOnPage Procedure 
PROCEDURE POpenSDOQueriesOnPage :
/*------------------------------------------------------------------------------
  Purpose:     Find all SDOs on page and if they are data target of an SDO off
               the page, reopen the query
               
               ** NOT CURRENTLY USED **
               
               This was originally designed to fix the problem I found in 9.1A
               where, when NOT using AppServer, the 'hidden SDO doesnt open the
               query' problem arose. More specifically, the query was opening
               but the browse was missing out it's top record!
               
               This routine was designed to run from selectPage, but it cause new
               problems itself so I tried to find a alternate fix.
               
               I finally fixed the problem by opening the query even when hidden,
               and I had to put a fix into dataAvailable in the browse to ensure
               all the records were being shown when the query opens and the
               browse is hidden.

------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER piPageNum AS INTEGER NO-UNDO.

  DEFINE VARIABLE VcPageTargets AS CHAR NO-UNDO.

  /* Find all SmartObjects on this page */
  DEFINE VARIABLE cPageN   AS CHARACTER NO-UNDO.
  DEFINE VARIABLE iObj     AS INTEGER   NO-UNDO.
  DEFINE VARIABLE cTargets AS CHARACTER NO-UNDO INIT "":U.
  DEFINE VARIABLE cEntry   AS CHARACTER NO-UNDO.
  
  {get PageNTarget cPageN}.
  DO iObj = 1 TO NUM-ENTRIES(cPageN):
    cEntry = ENTRY(iObj, cPageN).
    IF INT(ENTRY(2, cEntry, "|":U)) = piPageNum THEN
      cTargets = cTargets + (IF cTargets = "":U THEN "":U ELSE ",":U)
        + ENTRY(1, cEntry, "|":U).
  END.
  
  /* Got all SO's on page - now work through and check each one */
  DEFINE VARIABLE VhCurObj AS HANDLE NO-UNDO.
  DEFINE VARIABLE ViCount  AS INT    NO-UNDO.
  IF cTargets > "" THEN
  DO ViCount = 1 TO NUM-ENTRIES(cTargets):
    VhCurObj = WIDGET-HANDLE(ENTRY(ViCount,cTargets)).
    
    &SCOPED-DEFINE m POpenSDOQueriesOnPage IS checking OBJECT:
    {adbgmsg0.i TARGET-PROCEDURE:FILE-NAME VhCurObj:FILE-NAME}

    /* Check if its data-target of another SDO */
    DEFINE VARIABLE VhCurObjDataSource AS HANDLE NO-UNDO.
    {get dataSource VhCurObjDataSource VhCurObj}.
    IF NOT VALID-HANDLE(VhCurObjDataSource) THEN
        NEXT.

    /* Is the data source of this SDO on the same page as it?
       If it's in the list of objects on the current page then both are on the
       same page so don't need to worry about it */
    IF LOOKUP(STRING(VhCurObjDataSource),cTargets) > 0 THEN
        NEXT.

    &SCOP m OBJECT IS ON different PAGE FROM data SOURCE:
    {adbgmsg0.i TARGET-PROCEDURE:FILE-NAME VhCurObj:FILE-NAME VhCurObjDataSource:FILE-NAME}
    /* OK we do need to reopen the query? 
       Check if it's an SDO here? I've left this for now as other SO's may be
       data-targets and may need query refreshing
    */
    IF {fn getObjectType VhCurObj} = "SmartDataObject" THEN
    DO:
        /* Check that SDO query is already open - if so it needs a refresh */
        DEFINE VARIABLE VlQueryOpen             AS LOG              NO-UNDO.
        {get QueryOpen VlQueryOpen VhCurObj}.
        IF NOT VlQueryOpen THEN
        DO:
            &SCOP m rejecting AS QUERY NOT OPEN
            {adbgmsg0.i}
            NEXT.
        END.

        /* Ok now go on and open the query */
        &SCOPED-DEFINE m POpenSDOQueriesOnPage IS opening QUERY FOR OBJECT:
        {adbgmsg0.i TARGET-PROCEDURE:FILE-NAME VhCurObj:FILE-NAME}

        RUN dataavailable IN VhCurObj ("DIFFERENT").
        RUN fetchFirst IN VhCurObj.
    END.
  
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-PWindowCheckOnScreen) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE PWindowCheckOnScreen Procedure 
PROCEDURE PWindowCheckOnScreen :
/*------------------------------------------------------------------------------
  Purpose:     Check the window is on the screen, and if its not move it so its 
               hard up to the edge of the screen
------------------------------------------------------------------------------*/

    DEFINE VARIABLE VhContainerHandle           AS HANDLE               NO-UNDO.
    {get ContainerHandle VhContainerHandle}.

    IF VhContainerHandle:TYPE <> "WINDOW" THEN
    DO:
        MESSAGE "PWindowCheckOnScreen only works for Windows." SKIP
                "This object is not a window:" TARGET-PROCEDURE:FILE-NAME
            VIEW-AS ALERT-BOX ERROR.
        RETURN.
    END.

    &SCOP CONTAINER_TOTAL_WIDTH_PIXELS  (VhContainerHandle:WIDTH-PIXELS)
    /* Note: We could use the API to find the real total height of the window - this 25
       is just a decent guess */
    &SCOP CONTAINER_TOTAL_HEIGHT_PIXELS (VhContainerHandle:HEIGHT-PIXELS + 25)

    IF VhContainerHandle:X + {&CONTAINER_TOTAL_WIDTH_PIXELS} > SESSION:WORK-AREA-WIDTH-PIXELS THEN
        VhContainerHandle:X = SESSION:WORK-AREA-WIDTH-PIXELS - {&CONTAINER_TOTAL_WIDTH_PIXELS}.
    IF VhContainerHandle:Y + {&CONTAINER_TOTAL_HEIGHT_PIXELS} > SESSION:WORK-AREA-HEIGHT-PIXELS THEN
        VhContainerHandle:Y = SESSION:WORK-AREA-HEIGHT-PIXELS - {&CONTAINER_TOTAL_HEIGHT_PIXELS}.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-viewObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE viewObject Procedure 
PROCEDURE viewObject :
/*------------------------------------------------------------------------------
  Purpose:     Override to fix folder problem
------------------------------------------------------------------------------*/

    RUN SUPER.
    
    RUN PFixFolderZOrder IN TARGET-PROCEDURE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

