/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS fFrameWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrfrm.w - ADM2 SmartFrame Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */
     
DEF BUFFER xservice FOR service.     
DEF BUFFER xguest FOR guest.

subscribe to "refresh-stays" anywhere.

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER FRAME

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME staysBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES stay room room-type guest

/* Definitions for BROWSE staysBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-staysBrowse stay.room-num ~
guest.first-name + " " + guest.last-name stay.num-guests stay.start-date ~
stay.end-date stay.end-date - stay.start-date room-type.description ~
stay.price 
&Scoped-define ENABLED-FIELDS-IN-QUERY-staysBrowse 
&Scoped-define QUERY-STRING-staysBrowse FOR EACH stay ~
      WHERE stay.checked-out = FALSE NO-LOCK, ~
      EACH room OF stay NO-LOCK, ~
      EACH room-type OF room NO-LOCK, ~
      EACH guest OF stay ~
      WHERE guest.order = 1 NO-LOCK
&Scoped-define OPEN-QUERY-staysBrowse OPEN QUERY staysBrowse FOR EACH stay ~
      WHERE stay.checked-out = FALSE NO-LOCK, ~
      EACH room OF stay NO-LOCK, ~
      EACH room-type OF room NO-LOCK, ~
      EACH guest OF stay ~
      WHERE guest.order = 1 NO-LOCK.
&Scoped-define TABLES-IN-QUERY-staysBrowse stay room room-type guest
&Scoped-define FIRST-TABLE-IN-QUERY-staysBrowse stay
&Scoped-define SECOND-TABLE-IN-QUERY-staysBrowse room
&Scoped-define THIRD-TABLE-IN-QUERY-staysBrowse room-type
&Scoped-define FOURTH-TABLE-IN-QUERY-staysBrowse guest


/* Definitions for FRAME fMain                                          */
&Scoped-define OPEN-BROWSERS-IN-QUERY-fMain ~
    ~{&OPEN-QUERY-staysBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS reselFilters filterRoom findGuest ~
searchButton showPast staysBrowse checkIn checkOut updateStay deleteButton 
&Scoped-Define DISPLAYED-OBJECTS filterRoom findGuest showPast 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON checkIn 
     LABEL "Check-In..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON checkOut 
     LABEL "Check-Out..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON deleteButton 
     LABEL "Delete..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON reselFilters  NO-FOCUS
     LABEL "Reset Filters" 
     SIZE 15 BY 1.

DEFINE BUTTON searchButton 
     LABEL "Search" 
     SIZE 15 BY 1.

DEFINE BUTTON updateStay 
     LABEL "Update..." 
     SIZE 15 BY 1.14.

DEFINE VARIABLE filterRoom AS INTEGER FORMAT ">>>>>":U INITIAL 0 
     LABEL "Filter by Room" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE findGuest AS CHARACTER FORMAT "X(256)":U 
     LABEL "Filter by Guest" 
     VIEW-AS FILL-IN 
     SIZE 25 BY 1 NO-UNDO.

DEFINE VARIABLE showPast AS LOGICAL INITIAL no 
     LABEL "Show Past Accomodations" 
     VIEW-AS TOGGLE-BOX
     SIZE 34 BY .81 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY staysBrowse FOR 
      stay, 
      room, 
      room-type, 
      guest SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE staysBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS staysBrowse fFrameWin _STRUCTURED
  QUERY staysBrowse NO-LOCK DISPLAY
      stay.room-num COLUMN-LABEL "Room Num" FORMAT ">>>>9":U WIDTH 11.2
      guest.first-name + " " + guest.last-name COLUMN-LABEL "Guest" FORMAT "x(40)":U
            WIDTH 23.2
      stay.num-guests COLUMN-LABEL "Num Guests" FORMAT ">9":U WIDTH 12.2
      stay.start-date COLUMN-LABEL "Check-in" FORMAT "99/99/99":U
            WIDTH 10.2
      stay.end-date COLUMN-LABEL "Check-out" FORMAT "99/99/99":U
            WIDTH 10.2
      stay.end-date - stay.start-date COLUMN-LABEL "Days"
      room-type.description COLUMN-LABEL "Room Type" FORMAT "x(20)":U
      stay.price COLUMN-LABEL "Room Price" FORMAT "$ >>>,>>>,>>9":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 119 BY 9.52
         FONT 8 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     reselFilters AT ROW 1.48 COL 100.6 WIDGET-ID 18
     filterRoom AT ROW 1.48 COL 17.6 COLON-ALIGNED WIDGET-ID 20
     findGuest AT ROW 1.48 COL 50.6 COLON-ALIGNED WIDGET-ID 16
     searchButton AT ROW 1.48 COL 81.6 WIDGET-ID 32
     showPast AT ROW 2.91 COL 7 WIDGET-ID 22
     staysBrowse AT ROW 4.1 COL 4 WIDGET-ID 200
     checkIn AT ROW 14.33 COL 4 WIDGET-ID 26
     checkOut AT ROW 14.33 COL 21.6 WIDGET-ID 30
     updateStay AT ROW 14.33 COL 39.2 WIDGET-ID 28
     deleteButton AT ROW 14.33 COL 57 WIDGET-ID 6
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 125.2 BY 15.38
         FONT 8 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFrame
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: PERSISTENT-ONLY APPSERVER
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW fFrameWin ASSIGN
         HEIGHT             = 15.38
         WIDTH              = 125.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB fFrameWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW fFrameWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   NOT-VISIBLE FRAME-NAME                                               */
/* BROWSE-TAB staysBrowse showPast fMain */
ASSIGN 
       FRAME fMain:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME fMain
/* Query rebuild information for FRAME fMain
     _Options          = ""
     _Query            is NOT OPENED
*/  /* FRAME fMain */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE staysBrowse
/* Query rebuild information for BROWSE staysBrowse
     _TblList          = "hotel.stay,hotel.room OF hotel.stay,hotel.room-type OF hotel.room,hotel.guest OF hotel.stay"
     _Options          = "NO-LOCK"
     _TblOptList       = ",,,"
     _Where[1]         = "stay.checked-out = FALSE"
     _Where[4]         = "guest.order = 1"
     _FldNameList[1]   > hotel.stay.room-num
"stay.room-num" "Room Num" ? "integer" ? ? ? ? ? ? no ? no no "11.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > "_<CALC>"
"guest.first-name + "" "" + guest.last-name" "Guest" "x(40)" ? ? ? ? ? ? ? no ? no no "23.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > hotel.stay.num-guests
"stay.num-guests" "Num Guests" ? "integer" ? ? ? ? ? ? no ? no no "12.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[4]   > hotel.stay.start-date
"stay.start-date" "Check-in" ? "date" ? ? ? ? ? ? no ? no no "10.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[5]   > hotel.stay.end-date
"stay.end-date" "Check-out" ? "date" ? ? ? ? ? ? no ? no no "10.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[6]   > "_<CALC>"
"stay.end-date - stay.start-date" "Days" ? ? ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[7]   > hotel.room-type.description
"room-type.description" "Room Type" ? "character" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[8]   > hotel.stay.price
"stay.price" "Room Price" "$ >>>,>>>,>>9" "integer" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is OPENED
*/  /* BROWSE staysBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME checkIn
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL checkIn fFrameWin
ON CHOOSE OF checkIn IN FRAME fMain /* Check-In... */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdStayRid AS ROWID.
  DO TRANSACTION:
     RUN update-stay-dialog.w (INPUT rid, 
                               OUTPUT needRefresh, 
                               OUTPUT createdStayRid,
                               INPUT FALSE,
                               ?,
                               ?,
                               ?,
                               ?).

      IF needRefresh THEN DO:
         RUN refresh-stays.
         REPOSITION staysBrowse TO ROWID createdStayRid NO-ERROR.
      END.
      ELSE UNDO, LEAVE.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME checkOut
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL checkOut fFrameWin
ON CHOOSE OF checkOut IN FRAME fMain /* Check-Out... */
DO:
  DEF VAR needRefresh AS LOGICAL INIT FALSE.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(stay) THEN DO:
     {no-selected-records.i "accomodations"}
  END.

  IF stay.checked-out THEN DO:
     MESSAGE "This accomodation has aleady been checked out!"
        VIEW-AS ALERT-BOX ERROR TITLE "Already checked out".
     return no-apply. 
  END.

  DO TRANSACTION:
     rid = ROWID(stay).
     RUN update-stay-dialog.w (INPUT rid, 
                               OUTPUT needRefresh, 
                               OUTPUT unk,
                               INPUT TRUE,
                               ?,
                               ?,
                               ?,
                               ?).

     IF needRefresh THEN DO:
        RUN refresh-stays.
        REPOSITION staysBrowse TO ROWID rid NO-ERROR.
     END.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteButton fFrameWin
ON CHOOSE OF deleteButton IN FRAME fMain /* Delete... */
DO:
  IF NOT AVAIL(stay) THEN DO:
     {no-selected-records.i "accomodations"}  
  END.

  MESSAGE "Are you sure you want to delete accomodation of " +
     guest.first-name + " " + guest.last-name + "?"
     VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Deletion confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  DO TRANSACTION:
     FOR EACH xservice WHERE xservice.stay-id = stay.stay-id:
        DELETE xservice.
     END.
     FOR EACH xguest WHERE xguest.stay-id = stay.stay-id:
        DELETE xguest.
     END.
     FIND CURRENT stay EXCLUSIVE-LOCK.
     DELETE stay.
  END.
  
  RUN refresh-stays.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME filterRoom
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL filterRoom fFrameWin
ON ANY-KEY OF filterRoom IN FRAME fMain /* Filter by Room */
DO:
  IF LASTKEY = KEYCODE("RETURN") THEN DO:
     RUN refresh-stays.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findGuest
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findGuest fFrameWin
ON ANY-KEY OF findGuest IN FRAME fMain /* Filter by Guest */
DO:
  IF LASTKEY = KEYCODE("RETURN") THEN DO:
     RUN refresh-stays.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME reselFilters
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL reselFilters fFrameWin
ON CHOOSE OF reselFilters IN FRAME fMain /* Reset Filters */
DO:
   filterRoom = 0.
   findGuest = "".
   DISPLAY filterRoom findGuest WITH FRAME fMain.
   RUN refresh-stays.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME searchButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL searchButton fFrameWin
ON CHOOSE OF searchButton IN FRAME fMain /* Search */
DO:
  RUN refresh-stays.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME showPast
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL showPast fFrameWin
ON VALUE-CHANGED OF showPast IN FRAME fMain /* Show Past Accomodations */
DO:
  RUN refresh-stays.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME updateStay
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL updateStay fFrameWin
ON CHOOSE OF updateStay IN FRAME fMain /* Update... */
DO:
  DEF VAR needRefresh AS LOGICAL INIT FALSE.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(stay) THEN DO:
     {no-selected-records.i "accomodations"}
  END.

  DO TRANSACTION:
     rid = ROWID(stay).
     RUN update-stay-dialog.w (INPUT rid, 
                               OUTPUT needRefresh, 
                               OUTPUT unk,
                               INPUT FALSE,
                               ?,
                               ?,
                               ?,
                               ?).

     IF needRefresh THEN DO:
        RUN refresh-stays.
        REPOSITION staysBrowse TO ROWID rid NO-ERROR.
     END.
  END.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME staysBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK fFrameWin 


/* ***************************  Main Block  *************************** */

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   /* Now enable the interface  if in test mode - otherwise this happens when
      the object is explicitly initialized from its container. */
   RUN initializeObject.
&ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects fFrameWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI fFrameWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fMain.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI fFrameWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY filterRoom findGuest showPast 
      WITH FRAME fMain.
  ENABLE reselFilters filterRoom findGuest searchButton showPast staysBrowse 
         checkIn checkOut updateStay deleteButton 
      WITH FRAME fMain.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-stays fFrameWin 
PROCEDURE refresh-stays :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
{get-reservation-filter.i}

DEF VAR past AS LOGICAL.
past = showPast:INPUT-VALUE.

OPEN QUERY staysBrowse FOR
EACH stay WHERE
   (IF roomNum <> ? THEN stay.room-num = roomNum ELSE TRUE) AND
   (IF past THEN TRUE ELSE stay.checked-out = FALSE)
   NO-LOCK,
      EACH room OF stay NO-LOCK,
      EACH room-type OF room NO-LOCK,
      EACH guest OF stay WHERE
         guest.order = 1 AND
    (IF guestName <> ? THEN 
       guest.first-name + " " + guest.last-name MATCHES guestName ELSE TRUE)         
    NO-LOCK.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

