/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS fFrameWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrfrm.w - ADM2 SmartFrame Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEF BUFFER xroom-type FOR room-type.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER FRAME

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME ratesBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES rate room-type

/* Definitions for BROWSE ratesBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-ratesBrowse room-type.description ~
rate.start-date rate.end-date rate.rate 
&Scoped-define ENABLED-FIELDS-IN-QUERY-ratesBrowse 
&Scoped-define QUERY-STRING-ratesBrowse FOR EACH rate NO-LOCK, ~
      EACH room-type OF rate NO-LOCK
&Scoped-define OPEN-QUERY-ratesBrowse OPEN QUERY ratesBrowse FOR EACH rate NO-LOCK, ~
      EACH room-type OF rate NO-LOCK.
&Scoped-define TABLES-IN-QUERY-ratesBrowse rate room-type
&Scoped-define FIRST-TABLE-IN-QUERY-ratesBrowse rate
&Scoped-define SECOND-TABLE-IN-QUERY-ratesBrowse room-type


/* Definitions for FRAME fMain                                          */
&Scoped-define OPEN-BROWSERS-IN-QUERY-fMain ~
    ~{&OPEN-QUERY-ratesBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS roomTypeImage showPastRates ratesBrowse ~
addButton deleteButton updateButton 
&Scoped-Define DISPLAYED-OBJECTS showPastRates 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON addButton 
     LABEL "Add..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON deleteButton 
     LABEL "Delete..." 
     SIZE 15 BY 1.14.

DEFINE BUTTON updateButton 
     LABEL "Update..." 
     SIZE 15 BY 1.14.

DEFINE IMAGE roomTypeImage
     FILENAME "graphics/double.jpg":U
     SIZE-PIXELS 250 BY 167.

DEFINE VARIABLE showPastRates AS LOGICAL INITIAL no 
     LABEL "Show Past Rates" 
     VIEW-AS TOGGLE-BOX
     SIZE 24 BY .81 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY ratesBrowse FOR 
      rate, 
      room-type SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE ratesBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS ratesBrowse fFrameWin _STRUCTURED
  QUERY ratesBrowse NO-LOCK DISPLAY
      room-type.description COLUMN-LABEL "Room Type" FORMAT "x(20)":U
            WIDTH 27.2
      rate.start-date FORMAT "99/99/99":U WIDTH 10.2
      rate.end-date FORMAT "99/99/99":U WIDTH 10.2
      rate.rate FORMAT "$ >>>,>>9.99":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS SIZE 68 BY 10.95
         FONT 8 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     showPastRates AT ROW 1.48 COL 33 WIDGET-ID 4
     ratesBrowse AT ROW 2.67 COL 4 WIDGET-ID 200
     addButton AT ROW 14.33 COL 5 WIDGET-ID 6
     deleteButton AT ROW 14.33 COL 22 WIDGET-ID 8
     updateButton AT ROW 14.33 COL 39 WIDGET-ID 10
     roomTypeImage AT Y 35 X 365 WIDGET-ID 12
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 125.1 BY 15.38
         FONT 8 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFrame
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: PERSISTENT-ONLY APPSERVER
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW fFrameWin ASSIGN
         HEIGHT             = 15.38
         WIDTH              = 125.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB fFrameWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW fFrameWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   NOT-VISIBLE FRAME-NAME                                               */
/* BROWSE-TAB ratesBrowse showPastRates fMain */
ASSIGN 
       FRAME fMain:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME fMain
/* Query rebuild information for FRAME fMain
     _Options          = ""
     _Query            is NOT OPENED
*/  /* FRAME fMain */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE ratesBrowse
/* Query rebuild information for BROWSE ratesBrowse
     _TblList          = "hotel.rate,hotel.room-type OF hotel.rate"
     _Options          = "NO-LOCK"
     _FldNameList[1]   > hotel.room-type.description
"room-type.description" "Room Type" ? "character" ? ? ? ? ? ? no ? no no "27.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > hotel.rate.start-date
"rate.start-date" ? ? "date" ? ? ? ? ? ? no ? no no "10.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > hotel.rate.end-date
"rate.end-date" ? ? "date" ? ? ? ? ? ? no ? no no "10.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[4]   > hotel.rate.rate
"rate.rate" ? "$ >>>,>>9.99" "decimal" ? ? ? ? ? ? no ? no no ? yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _Query            is OPENED
*/  /* BROWSE ratesBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME addButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL addButton fFrameWin
ON CHOOSE OF addButton IN FRAME fMain /* Add... */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR createdRateRid AS ROWID.
  RUN update-rate-dialog.w (INPUT rid, OUTPUT needRefresh, OUTPUT createdRateRid).

  IF needRefresh THEN DO:
     RUN refresh-rates.
     REPOSITION ratesBrowse TO ROWID createdRateRid NO-ERROR.
     RUN update-room-image.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteButton fFrameWin
ON CHOOSE OF deleteButton IN FRAME fMain /* Delete... */
DO:
 IF NOT AVAIL(rate) THEN DO:
     {no-selected-records.i "rates"}  
  END.

  FIND FIRST xroom-type WHERE xroom-type.room-type =  rate.room-type.
  MESSAGE "Are you sure you want to delete rate for " +
     STRING(xroom-type.DESCRIPTION) " " + 
     STRING(rate.start-date) + " - " +
     STRING(rate.end-date) + " ($" +
     STRING(rate.rate) + ")?"
      VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO TITLE "Deletion confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  FIND CURRENT rate EXCLUSIVE-LOCK.
  DELETE rate.

  RUN refresh-rates.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME ratesBrowse
&Scoped-define SELF-NAME ratesBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL ratesBrowse fFrameWin
ON VALUE-CHANGED OF ratesBrowse IN FRAME fMain
DO:
  RUN update-room-image.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME showPastRates
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL showPastRates fFrameWin
ON VALUE-CHANGED OF showPastRates IN FRAME fMain /* Show Past Rates */
DO:
  RUN refresh-rates.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME updateButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL updateButton fFrameWin
ON CHOOSE OF updateButton IN FRAME fMain /* Update... */
DO:
  DEF VAR needRefresh AS LOGICAL.
  DEF VAR rid AS ROWID.
  DEF VAR unk AS ROWID.

  IF NOT AVAIL(rate) THEN DO:
     {no-selected-records.i "rates"}
  END.

  rid = ROWID(rate).
  RUN update-rate-dialog.w (INPUT rid, OUTPUT needRefresh, OUTPUT unk).

  IF needRefresh THEN DO:
     RUN refresh-rates.
     REPOSITION ratesBrowse TO ROWID rid NO-ERROR.
     RUN update-room-image.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK fFrameWin 


/* ***************************  Main Block  *************************** */

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   /* Now enable the interface  if in test mode - otherwise this happens when
      the object is explicitly initialized from its container. */
   RUN initializeObject.
&ENDIF

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects fFrameWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI fFrameWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fMain.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI fFrameWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY showPastRates 
      WITH FRAME fMain.
  ENABLE roomTypeImage showPastRates ratesBrowse addButton deleteButton 
         updateButton 
      WITH FRAME fMain.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initializeObject fFrameWin 
PROCEDURE initializeObject :
/*------------------------------------------------------------------------------
  Purpose:     Super Override
  Parameters:  
  Notes:       
------------------------------------------------------------------------------*/

  /* Code placed here will execute PRIOR to standard behavior. */

  RUN SUPER.

  /* Code placed here will execute AFTER standard behavior.    */
  RUN refresh-rates.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-rates fFrameWin 
PROCEDURE refresh-rates :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR val AS LOGICAL.
val = showPastRates:INPUT-VALUE IN FRAME fMain.

IF val THEN DO:
   OPEN QUERY ratesBrowse FOR EACH rate NO-LOCK,
        EACH room-type OF rate NO-LOCK.
END.
ELSE DO:
   OPEN QUERY ratesBrowse FOR EACH rate NO-LOCK
         WHERE rate.end-date >= TODAY,
            EACH room-type OF rate NO-LOCK.
END.

RUN update-room-image.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE update-room-image fFrameWin 
PROCEDURE update-room-image :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
   IF AVAIL(rate) THEN DO:
     FIND room-type WHERE room-type.room-type = rate.room-type.
     (roomTypeImage:LOAD-IMAGE(room-type.IMAGE) IN FRAME fMain) NO-ERROR.
     roomTypeImage:VISIBLE = TRUE.
  END.
  ELSE DO:
     roomTypeImage:VISIBLE = FALSE. 
  END.


END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

