/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
/* Connected Databases 
          hotel            PROGRESS
*/
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS fFrameWin 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrfrm.w - ADM2 SmartFrame Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions ---                                       */

DEF BUFFER xroom FOR room.
DEF TEMP-TABLE number FIELD num AS INTEGER.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartFrame
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER FRAME

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME fMain
&Scoped-define BROWSE-NAME roomsBrowse

/* Internal Tables (found by Frame, Query & Browse Queries)             */
&Scoped-define INTERNAL-TABLES room room-type

/* Definitions for BROWSE roomsBrowse                                   */
&Scoped-define FIELDS-IN-QUERY-roomsBrowse room.room-num room.floor ~
room-type.description room.active 
&Scoped-define ENABLED-FIELDS-IN-QUERY-roomsBrowse 
&Scoped-define QUERY-STRING-roomsBrowse FOR EACH room NO-LOCK, ~
      EACH room-type OF room NO-LOCK
&Scoped-define OPEN-QUERY-roomsBrowse OPEN QUERY roomsBrowse FOR EACH room NO-LOCK, ~
      EACH room-type OF room NO-LOCK.
&Scoped-define TABLES-IN-QUERY-roomsBrowse room room-type
&Scoped-define FIRST-TABLE-IN-QUERY-roomsBrowse room
&Scoped-define SECOND-TABLE-IN-QUERY-roomsBrowse room-type


/* Definitions for FRAME fMain                                          */
&Scoped-define OPEN-BROWSERS-IN-QUERY-fMain ~
    ~{&OPEN-QUERY-roomsBrowse}

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS floorSelect findRoom findButton roomsBrowse ~
addRooms deleteRooms updateRoom activateRooms 
&Scoped-Define DISPLAYED-OBJECTS floorSelect findRoom 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */


/* Definitions of the field level widgets                               */
DEFINE BUTTON activateRooms 
     LABEL "Activate/Deactivate Rooms..." 
     SIZE 33 BY 1.14.

DEFINE BUTTON addRooms 
     LABEL "Add Rooms..." 
     SIZE 19 BY 1.14.

DEFINE BUTTON deleteRooms 
     LABEL "Delete Rooms..." 
     SIZE 21 BY 1.14.

DEFINE BUTTON findButton 
     LABEL "Find" 
     SIZE 15 BY 1.

DEFINE BUTTON updateRoom 
     LABEL "Update Room..." 
     SIZE 21 BY 1.14.

DEFINE VARIABLE floorSelect AS CHARACTER FORMAT "X(256)":U 
     LABEL "Floor" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     DROP-DOWN-LIST
     SIZE 19 BY 1 NO-UNDO.

DEFINE VARIABLE findRoom AS INTEGER FORMAT ">>>>>":U INITIAL 0 
     LABEL "Find Room" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

/* Query definitions                                                    */
&ANALYZE-SUSPEND
DEFINE QUERY roomsBrowse FOR 
      room, 
      room-type SCROLLING.
&ANALYZE-RESUME

/* Browse definitions                                                   */
DEFINE BROWSE roomsBrowse
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _DISPLAY-FIELDS roomsBrowse fFrameWin _STRUCTURED
  QUERY roomsBrowse NO-LOCK DISPLAY
      room.room-num FORMAT ">>>>9":U WIDTH 16.2
      room.floor FORMAT ">9":U WIDTH 9.2
      room-type.description COLUMN-LABEL "Room Type" FORMAT "x(20)":U
            WIDTH 77.2
      room.active FORMAT "yes/no":U
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME
    WITH NO-ROW-MARKERS SEPARATORS MULTIPLE SIZE 119 BY 10.57
         FONT 8 FIT-LAST-COLUMN.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME fMain
     floorSelect AT ROW 1.48 COL 18 COLON-ALIGNED WIDGET-ID 2
     findRoom AT ROW 1.48 COL 53 COLON-ALIGNED WIDGET-ID 4
     findButton AT ROW 1.48 COL 74 WIDGET-ID 14
     roomsBrowse AT ROW 3.05 COL 4 WIDGET-ID 200
     addRooms AT ROW 14.1 COL 5 WIDGET-ID 6
     deleteRooms AT ROW 14.1 COL 27 WIDGET-ID 8
     updateRoom AT ROW 14.1 COL 51 WIDGET-ID 12
     activateRooms AT ROW 14.1 COL 75 WIDGET-ID 10
    WITH 1 DOWN NO-BOX KEEP-TAB-ORDER OVERLAY 
         SIDE-LABELS NO-UNDERLINE THREE-D 
         AT COL 1 ROW 1
         SIZE 125.1 BY 15.38
         FONT 8 WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartFrame
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: PERSISTENT-ONLY
 */

/* This procedure should always be RUN PERSISTENT.  Report the error,  */
/* then cleanup and return.                                            */
IF NOT THIS-PROCEDURE:PERSISTENT THEN DO:
  MESSAGE "{&FILE-NAME} should only be RUN PERSISTENT.":U
          VIEW-AS ALERT-BOX ERROR BUTTONS OK.
  RETURN.
END.

&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW fFrameWin ASSIGN
         HEIGHT             = 15.38
         WIDTH              = 125.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB fFrameWin 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR WINDOW fFrameWin
  VISIBLE,,RUN-PERSISTENT                                               */
/* SETTINGS FOR FRAME fMain
   NOT-VISIBLE FRAME-NAME                                               */
/* BROWSE-TAB roomsBrowse findButton fMain */
ASSIGN 
       FRAME fMain:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK FRAME fMain
/* Query rebuild information for FRAME fMain
     _Options          = ""
     _Query            is NOT OPENED
*/  /* FRAME fMain */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _QUERY-BLOCK BROWSE roomsBrowse
/* Query rebuild information for BROWSE roomsBrowse
     _TblList          = "hotel.room,hotel.room-type OF hotel.room"
     _Options          = "NO-LOCK"
     _FldNameList[1]   > hotel.room.room-num
"room.room-num" ? ? "integer" ? ? ? ? ? ? no ? no no "16.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[2]   > hotel.room.floor
"room.floor" ? ? "integer" ? ? ? ? ? ? no ? no no "9.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[3]   > hotel.room-type.description
"room-type.description" "Room Type" ? "character" ? ? ? ? ? ? no ? no no "77.2" yes no no "U" "" "" "" "" "" "" 0 no 0 no no
     _FldNameList[4]   = hotel.room.active
     _Query            is OPENED
*/  /* BROWSE roomsBrowse */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME activateRooms
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL activateRooms fFrameWin
ON CHOOSE OF activateRooms IN FRAME fMain /* Activate/Deactivate Rooms... */
DO:
  DEF VAR i AS INTEGER.
  DEF VAR cnt AS INTEGER.
  DEF VAR doActivateRooms AS LOGICAL.
  
  cnt = BROWSE roomsBrowse:NUM-SELECTED-ROWS.

  IF cnt = 0 THEN DO:
     {no-selected-records.i "rooms"}  
  END.

  RUN activate-rooms-dialog.w (INPUT cnt, OUTPUT doActivateRooms).

  IF doActivateRooms = ? THEN DO:
     RETURN NO-APPLY.
  END.
     
  REPEAT i = 1 TO cnt:
     BROWSE roomsBrowse:FETCH-SELECTED-ROW(i).
     
     FIND xroom EXCLUSIVE-LOCK WHERE xroom.room-num = room.room-num.
     ASSIGN xroom.ACTIVE = doActivateRooms.
     RELEASE xroom.
  END.

  BROWSE roomsBrowse:REFRESH().

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME addRooms
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL addRooms fFrameWin
ON CHOOSE OF addRooms IN FRAME fMain /* Add Rooms... */
DO:
   DEF VAR needRefresh AS LOGICAL.
   RUN 'add-rooms-dialog.w' (OUTPUT needRefresh).
   IF needRefresh THEN DO: 
      RUN update-floors.
      RUN refresh-for-current-floor.
   END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME deleteRooms
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL deleteRooms fFrameWin
ON CHOOSE OF deleteRooms IN FRAME fMain /* Delete Rooms... */
DO:
  DEF VAR i AS INTEGER.
  DEF VAR cnt AS INTEGER.
  cnt = BROWSE roomsBrowse:NUM-SELECTED-ROWS.

  IF cnt = 0 THEN DO:
     {no-selected-records.i "rooms"}  
  END.

  MESSAGE "Are you sure you want to delete " + string(cnt) + " room(s)?"
      VIEW-AS ALERT-BOX QUESTION BUTTONS YES-NO title "Delete confirmation"
        UPDATE ret AS LOGICAL.
  IF NOT ret THEN RETURN NO-APPLY.

  FOR EACH number:
     DELETE number.
  END.
  
  REPEAT i = 1 TO cnt:
     BROWSE roomsBrowse:FETCH-SELECTED-ROW(i).
     CREATE number. number.num = room.room-num.
  END.

  FOR EACH number:
     FIND room WHERE room.room-num = number.num.
     DELETE room.
     DELETE number.
  END.

  RUN refresh-for-current-floor.

END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findButton
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findButton fFrameWin
ON CHOOSE OF findButton IN FRAME fMain /* Find */
DO:
  RUN find-room.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME findRoom
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL findRoom fFrameWin
ON ANY-KEY OF findRoom IN FRAME fMain /* Find Room */
DO:
  IF LASTKEY = KEYCODE("RETURN") THEN DO:
     RUN find-room.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME floorSelect
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL floorSelect fFrameWin
ON VALUE-CHANGED OF floorSelect IN FRAME fMain /* Floor */
DO:
  RUN refresh-for-current-floor.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME updateRoom
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL updateRoom fFrameWin
ON CHOOSE OF updateRoom IN FRAME fMain /* Update Room... */
DO:
  DEF VAR cnt AS INTEGER.
  DEF VAR needRefresh AS LOGICAL.

  cnt = BROWSE roomsBrowse:NUM-SELECTED-ROWS.

  DEF VAR h AS HANDLE.
  IF cnt = 0 THEN DO:
     {no-selected-records.i "rooms"}  
  END.

  def var rid as rowid.
  rid = rowid(room).
  
  BROWSE roomsBrowse:FETCH-SELECTED-ROW(cnt).
     
  RUN update-room-dialog.w (INPUT room.room-num, OUTPUT needRefresh).

  IF needRefresh THEN DO:
     RUN refresh-for-current-floor.
     reposition roomsBrowse to rowid rid no-error.
  END.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define BROWSE-NAME roomsBrowse
&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK fFrameWin 


/* ***************************  Main Block  *************************** */

&IF DEFINED(UIB_IS_RUNNING) <> 0 &THEN
   /* Now enable the interface  if in test mode - otherwise this happens when
      the object is explicitly initialized from its container. */
   RUN initializeObject.
&ENDIF

RUN update-floors.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects fFrameWin  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI fFrameWin  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME fMain.
  IF THIS-PROCEDURE:PERSISTENT THEN DELETE PROCEDURE THIS-PROCEDURE.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI fFrameWin  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY floorSelect findRoom 
      WITH FRAME fMain.
  ENABLE floorSelect findRoom findButton roomsBrowse addRooms deleteRooms 
         updateRoom activateRooms 
      WITH FRAME fMain.
  {&OPEN-BROWSERS-IN-QUERY-fMain}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE find-room fFrameWin 
PROCEDURE find-room :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR findRoomNum AS INTEGER.
DEF VAR selRoomNum AS INTEGER.
     
findRoomNum = findRoom:INPUT-VALUE IN FRAME fMain.

FIND FIRST xroom WHERE xroom.room-num = findRoomNum NO-ERROR.
IF NOT AVAIL(xroom) THEN DO:
   MESSAGE "Cannot find room " + STRING(findRoomNum) 
     VIEW-AS ALERT-BOX ERROR title "No room found".
   RETURN.
END.

selRoomNum = ?.
selRoomNum = floorSelect:INPUT-VALUE NO-ERROR.
IF selRoomNum <> ? AND selRoomNum <> xroom.floor THEN DO:
   floorSelect:SCREEN-VALUE = "All floors".
   APPLY "value-changed" TO floorSelect.
END.

REPOSITION roomsBrowse TO ROWID ROWID(xroom) NO-ERROR.
roomsBrowse:DESELECT-ROWS().
roomsBrowse:SELECT-FOCUSED-ROW().

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE refresh-for-current-floor fFrameWin 
PROCEDURE refresh-for-current-floor :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/

  DEF VAR val AS INTEGER.
  val = ?.
  val = floorSelect:INPUT-VALUE IN FRAME fMain NO-ERROR.

  IF val <> ? THEN DO:
     OPEN QUERY roomsBrowse FOR EACH room NO-LOCK, 
        EACH room-type OF hotel.room NO-LOCK 
        WHERE room.floor = val.   
  END.
  ELSE DO:
     OPEN QUERY roomsBrowse FOR EACH room NO-LOCK,
        EACH room-type OF room NO-LOCK.
  END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE update-floors fFrameWin 
PROCEDURE update-floors :
/*------------------------------------------------------------------------------
  Purpose: update floor selection combo box     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR items AS CHAR INIT "All floors".

FOR EACH xroom NO-LOCK BREAK BY xroom.floor:
   IF FIRST-OF(xroom.floor) THEN DO:
      items = items + "," + STRING(xroom.floor). 
   END.
END.
floorSelect:LIST-ITEMS IN FRAME fMain = items.
floorSelect:SCREEN-VALUE IN FRAME fMain = "All floors".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

