/*
 * Copyright 2016-2017 Golden Code Development Corporation
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software
 * and associated documentation files (the "Software"),  to deal in the Software without
 * restriction, including without limitation the rights to use, copy, modify, merge, publish,
 * distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all copies or
 * substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 * DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12 GUI ADM2
&ANALYZE-RESUME
&Scoped-define WINDOW-NAME CURRENT-WINDOW
&Scoped-define FRAME-NAME gDialog
{adecomm/appserv.i}
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS gDialog 
/*------------------------------------------------------------------------

  File: 

  Description: from cntnrdlg.w - ADM2 SmartDialog Template

  Input Parameters:
      <none>

  Output Parameters:
      <none>

  Author: 

  Created: 
------------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* Create an unnamed pool to store all the widgets created 
     by this procedure. This is a good default which assures
     that this procedure's triggers and internal procedures 
     will execute in this procedure's storage, and that proper
     cleanup will occur on deletion of the procedure. */

CREATE WIDGET-POOL.

/* ***************************  Definitions  ************************** */

/* Parameters Definitions ---                                           */

/* Local Variable Definitions --- */
                                  
{def-update-params.i}

DEF BUFFER xreservation FOR reservation.
DEF BUFFER xstay FOR stay.

DEF VAR stay-guest-name AS CHAR INIT "".

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE SmartDialog
&Scoped-define DB-AWARE no

&Scoped-define ADM-CONTAINER DIALOG-BOX

&Scoped-define ADM-SUPPORTED-LINKS Data-Target,Data-Source,Page-Target,Update-Source,Update-Target

/* Name of designated FRAME-NAME and/or first browse and/or first query */
&Scoped-define FRAME-NAME gDialog

/* Standard List Definitions                                            */
&Scoped-Define ENABLED-OBJECTS endDatePicker guestName roomNumber ~
numberOfGuests startDate endDate Btn_OK Btn_Cancel startDatePicker roomType ~
reservationDays priceText 
&Scoped-Define DISPLAYED-OBJECTS guestName roomNumber numberOfGuests ~
startDate endDate roomType reservationDays priceText 

/* Custom List Definitions                                              */
/* List-1,List-2,List-3,List-4,List-5,List-6                            */

/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* ***********************  Control Definitions  ********************** */

/* Define a dialog box                                                  */

/* Definitions of the field level widgets                               */
DEFINE BUTTON Btn_Cancel AUTO-END-KEY 
     LABEL "Cancel" 
     SIZE 15 BY 1.14.

DEFINE BUTTON Btn_OK AUTO-GO 
     LABEL "Update" 
     SIZE 15 BY 1.14.

DEFINE BUTTON endDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE BUTTON startDatePicker 
     IMAGE-UP FILE "graphics/calendar.bmp":U
     IMAGE-INSENSITIVE FILE "graphics/calendar-disabled.bmp":U NO-FOCUS
     LABEL "" 
     SIZE 6 BY 1.19.

DEFINE VARIABLE roomNumber AS CHARACTER 
     LABEL "Room Number" 
     VIEW-AS COMBO-BOX INNER-LINES 5
     LIST-ITEMS "101","102","203","204" 
     DROP-DOWN
     SIZE 16 BY 1 NO-UNDO.

DEFINE VARIABLE endDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-out Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE guestName AS CHARACTER FORMAT "X(256)":U 
     LABEL "Guest Name" 
     VIEW-AS FILL-IN 
     SIZE 41 BY 1 NO-UNDO.

DEFINE VARIABLE priceText AS CHARACTER FORMAT "X(256)":U 
     LABEL "Price" 
      VIEW-AS TEXT 
     SIZE 48 BY .62 NO-UNDO.

DEFINE VARIABLE reservationDays AS INTEGER FORMAT ">>>>>9":U INITIAL 0 
     LABEL "Days" 
      VIEW-AS TEXT 
     SIZE 14 BY .62 NO-UNDO.

DEFINE VARIABLE roomType AS CHARACTER FORMAT "X(256)":U 
     LABEL "Room Type" 
      VIEW-AS TEXT 
     SIZE 34 BY .62 NO-UNDO.

DEFINE VARIABLE startDate AS DATE FORMAT "99/99/99":U 
     LABEL "Check-in Date" 
     VIEW-AS FILL-IN 
     SIZE 14 BY 1 NO-UNDO.

DEFINE VARIABLE numberOfGuests AS INTEGER 
     VIEW-AS RADIO-SET HORIZONTAL
     RADIO-BUTTONS 
          "1", 1,
"2", 2,
"3", 3,
"4", 4
     SIZE 22 BY .95 NO-UNDO.


/* ************************  Frame Definitions  *********************** */

DEFINE FRAME gDialog
     endDatePicker AT ROW 8.14 COL 36.6 WIDGET-ID 14
     guestName AT ROW 1.48 COL 19 COLON-ALIGNED WIDGET-ID 2
     roomNumber AT ROW 2.91 COL 19 COLON-ALIGNED WIDGET-ID 4
     numberOfGuests AT ROW 5.38 COL 3 WIDGET-ID 6 LABEL "Number of Guests"
     startDate AT ROW 6.76 COL 19 COLON-ALIGNED WIDGET-ID 18
     endDate AT ROW 8.19 COL 19 COLON-ALIGNED WIDGET-ID 16
     Btn_OK AT ROW 12.33 COL 4
     Btn_Cancel AT ROW 12.33 COL 21
     startDatePicker AT ROW 6.67 COL 36.6 WIDGET-ID 20
     roomType AT ROW 4.33 COL 19 COLON-ALIGNED WIDGET-ID 22
     reservationDays AT ROW 9.62 COL 19 COLON-ALIGNED WIDGET-ID 24
     priceText AT ROW 10.76 COL 19 COLON-ALIGNED WIDGET-ID 26
    WITH VIEW-AS DIALOG-BOX KEEP-TAB-ORDER
         SIDE-LABELS NO-UNDERLINE THREE-D  SCROLLABLE 
         FONT 8
         TITLE "Update Reservation"
         DEFAULT-BUTTON Btn_OK CANCEL-BUTTON Btn_Cancel WIDGET-ID 100.


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: SmartDialog
   Allow: Basic,Browse,DB-Fields,Query,Smart
   Container Links: Data-Target,Data-Source,Page-Target,Update-Source,Update-Target
   Other Settings: APPSERVER
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _INCLUDED-LIB gDialog 
/* ************************* Included-Libraries *********************** */

{src/adm2/containr.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME




/* ***********  Runtime Attributes and AppBuilder Settings  *********** */

&ANALYZE-SUSPEND _RUN-TIME-ATTRIBUTES
/* SETTINGS FOR DIALOG-BOX gDialog
   FRAME-NAME                                                           */
ASSIGN 
       FRAME gDialog:SCROLLABLE       = FALSE
       FRAME gDialog:HIDDEN           = TRUE.

/* _RUN-TIME-ATTRIBUTES-END */
&ANALYZE-RESUME


/* Setting information for Queries and Browse Widgets fields            */

&ANALYZE-SUSPEND _QUERY-BLOCK DIALOG-BOX gDialog
/* Query rebuild information for DIALOG-BOX gDialog
     _Options          = "SHARE-LOCK"
     _Query            is NOT OPENED
*/  /* DIALOG-BOX gDialog */
&ANALYZE-RESUME

 



/* ************************  Control Triggers  ************************ */

&Scoped-define SELF-NAME gDialog
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL gDialog gDialog
ON WINDOW-CLOSE OF FRAME gDialog /* Update Reservation */
DO:  
  /* Add Trigger to equate WINDOW-CLOSE to END-ERROR. */
  APPLY "END-ERROR":U TO SELF.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME Btn_OK
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL Btn_OK gDialog
ON CHOOSE OF Btn_OK IN FRAME gDialog /* Update */
DO:
   IF guestName:INPUT-VALUE = ? OR trim(guestName:INPUT-VALUE) = "" THEN DO:
      MESSAGE "Specify Guest Name!" VIEW-AS ALERT-BOX ERROR title "No guest name specified".
      RETURN NO-APPLY.
   END.

   {check-date-price.i TRUE}
   
   IF recordRid = ? THEN DO:
      CREATE reservation.
      createdRecordRid = ROWID(reservation).
   END.
   ELSE DO:
      FIND reservation WHERE ROWID(reservation) = recordRid.   
   END.

   ASSIGN reservation.guest = TRIM(guestName:INPUT-VALUE)
          reservation.room-num = roomNumber:INPUT-VALUE 
          reservation.num-guests = numberOfGuests:INPUT-VALUE 
          reservation.start-date = date1
          reservation.end-date = date2
          reservation.price = price.

   needRefresh = YES.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDate gDialog
ON VALUE-CHANGED OF endDate IN FRAME gDialog /* Check-out Date */
DO:
   RUN refresh-days-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME endDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL endDatePicker gDialog
ON CHOOSE OF endDatePicker IN FRAME gDialog
DO:
  {pick-date.i "Check-out Date" endDate gDialog}
  RUN refresh-days-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME roomNumber
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL roomNumber gDialog
ON VALUE-CHANGED OF roomNumber IN FRAME gDialog /* Room Number */
DO:
  RUN update-room-type.
  RUN refresh-days-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDate
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDate gDialog
ON VALUE-CHANGED OF startDate IN FRAME gDialog /* Check-in Date */
DO:
   RUN refresh-days-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&Scoped-define SELF-NAME startDatePicker
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CONTROL startDatePicker gDialog
ON CHOOSE OF startDatePicker IN FRAME gDialog
DO:
  {pick-date.i "Check-in Date" startDate gDialog}
  RUN refresh-days-price.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&UNDEFINE SELF-NAME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK gDialog 


/* ***************************  Main Block  *************************** */

{calc-days.i gDialog}
{calc-price.i gDialog}

{fill-rooms.i}


IF recordRid = ? THEN DO:
   FRAME gDialog:TITLE = "Add Reservation".
   Btn_OK:LABEL = "Add".
END.
ELSE DO:
   FRAME gDialog:TITLE = "Update Reservation".
   Btn_OK:LABEL = "Update".

   FIND reservation WHERE ROWID(reservation) = recordRid.
   ASSIGN guestName = reservation.guest
          roomNumber = string(reservation.room-num)
          numberOfGuests = reservation.num-guests
          startDate = reservation.start-date
          endDate = reservation.end-date.
   DISPLAY guestName roomNumber numberOfGuests startDate endDate WITH FRAME gDialog.
   
   RUN update-room-type.
   RUN refresh-days-price.
END.


{src/adm2/dialogmn.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE adm-create-objects gDialog  _ADM-CREATE-OBJECTS
PROCEDURE adm-create-objects :
/*------------------------------------------------------------------------------
  Purpose:     Create handles for all SmartObjects used in this procedure.
               After SmartObjects are initialized, then SmartLinks are added.
  Parameters:  <none>
------------------------------------------------------------------------------*/

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE disable_UI gDialog  _DEFAULT-DISABLE
PROCEDURE disable_UI :
/*------------------------------------------------------------------------------
  Purpose:     DISABLE the User Interface
  Parameters:  <none>
  Notes:       Here we clean-up the user-interface by deleting
               dynamic widgets we have created and/or hide 
               frames.  This procedure is usually called when
               we are ready to "clean-up" after running.
------------------------------------------------------------------------------*/
  /* Hide all frames. */
  HIDE FRAME gDialog.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE enable_UI gDialog  _DEFAULT-ENABLE
PROCEDURE enable_UI :
/*------------------------------------------------------------------------------
  Purpose:     ENABLE the User Interface
  Parameters:  <none>
  Notes:       Here we display/view/enable the widgets in the
               user-interface.  In addition, OPEN all queries
               associated with each FRAME and BROWSE.
               These statements here are based on the "Other 
               Settings" section of the widget Property Sheets.
------------------------------------------------------------------------------*/
  DISPLAY guestName roomNumber numberOfGuests startDate endDate roomType 
          reservationDays priceText 
      WITH FRAME gDialog.
  ENABLE endDatePicker guestName roomNumber numberOfGuests startDate endDate 
         Btn_OK Btn_Cancel startDatePicker roomType reservationDays priceText 
      WITH FRAME gDialog.
  VIEW FRAME gDialog.
  {&OPEN-BROWSERS-IN-QUERY-gDialog}
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE update-room-type gDialog 
PROCEDURE update-room-type :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
DEF VAR num AS INTEGER.
DEF VAR i AS INTEGER.
DEF VAR radioButtons AS CHAR.
num = roomNumber:INPUT-VALUE IN FRAME gDialog.

FIND FIRST room WHERE room.room-num = num NO-ERROR.
IF NOT AVAIL(room) THEN DO:
   roomType = "Specify Room Number". 
   DISABLE numberOfGuests WITH FRAME gDialog.
END.
ELSE DO:
   FIND room-type WHERE room-type.room-type = room.room-type.
   roomType = room-type.DESCRIPTION.
   
   radioButtons = "".
   REPEAT i = 1 TO room-type.max-persons:
       IF radioButtons <> "" THEN DO:
          radioButtons = radioButtons + ",".
       END.
       radioButtons = radioButtons + STRING(i) + "," + STRING(i).
   END.
   numberOfGuests:RADIO-BUTTONS = radioButtons.

   ENABLE numberOfGuests WITH FRAME gDialog.
END.

DISPLAY roomType WITH FRAME gDialog. 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

